<?php
namespace App\Http\Controllers\Api;

use App\Service\EmployeeService;
use App\Service\TokenService;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

//登录
class LoginController extends BaseController
{
    const MOBILE = '[mobile]';// 手机端
    const PERSONAL_COMPUTER = '[personalComputer]';// 电脑端

    public static $port = [
        self::MOBILE => '',
        self::PERSONAL_COMPUTER => '',
    ];

    public function login(Request $request){
        $data = $request->only("account","password");

        //登录
        $result = (new EmployeeService())->loginRule($data);
        list($bool, $return) = $result;
        if(! $bool) return $this->json_return(201,'',$return);

        //日志
        $res = Log::channel('login')->info("登录成功", $return);

        //生成token
        $jwtToken = TokenService::getToken($return['id']);
        $jwtToken = self::PERSONAL_COMPUTER . $jwtToken;

        return $this->json_return(200,'', ['token' => $jwtToken, 'emp_name'=>$return['name']]);
    }

    public function loginMobile(Request $request){
        $data = $request->only("account","password");

        //登录
        $result = (new EmployeeService())->loginRule($data);
        list($bool, $return) = $result;
        if(! $bool) return $this->json_return(201,'',$return);

        //生成token
        $jwtToken = TokenService::getToken($return['id']);
        $jwtToken = self::MOBILE . $jwtToken;

        return $this->json_return(200,'', ['token' => $jwtToken]);
    }
}
